set define off;
set sqlprefix off;


create or replace procedure drupaloracle_to_oracleproject(p_schema varchar2,p_blob_prefix varchar2)
as
  type refcur is ref cursor;
  c_cur     refcur;
  v_tab     varchar2(30);
  v_col     varchar2(30);
  v_schema  varchar2(30):= upper(p_schema);
begin
  
  open c_cur for 'select a.table_name, a.column_name from "'||v_schema||'".blob_column a, all_tab_columns b where a.table_name= b.table_name and b.column_name= a.column_name and b.owner= '''||v_schema||''' and data_type=''NUMBER''';
  
  loop
  
    fetch c_Cur into v_tab, v_col;
    exit when c_cur%notfound;
    
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" add (newblobcol varchar2(4000 char))';
    execute immediate 'update "'||v_schema||'"."'||v_tab||'" set newblobcol= '''||p_blob_prefix||'''||"'||v_col||'"';
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" drop column "'||v_col||'"';
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" rename column newblobcol to "'||v_col||'"';
  
  end loop;
  
  close c_cur;

  open c_cur for 'select a.table_name, a.column_name from all_tab_columns a where a.owner= '''||v_schema||''' and data_type=''CLOB''';
  
  loop
  
    fetch c_Cur into v_tab, v_col;
    exit when c_cur%notfound;
    
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" add (newblobcol varchar2(4000 char))';
    
    execute immediate 'declare
                           v_blob blob;
                           v_blob_handle number;
 procedure c2b( c IN CLOB , res in out BLOB)
IS
pos PLS_INTEGER := 1;
buffer RAW( 32767 );
lob_len PLS_INTEGER := DBMS_LOB.getLength( c );
BEGIN
DBMS_LOB.OPEN( res, DBMS_LOB.LOB_ReadWrite );

LOOP
buffer := UTL_RAW.cast_to_raw( DBMS_LOB.SUBSTR( c, 16000, pos ) );

IF UTL_RAW.LENGTH( buffer ) > 0 THEN
DBMS_LOB.writeAppend( res, UTL_RAW.LENGTH( buffer ), buffer );
END IF;

pos := pos + 16000;
EXIT WHEN pos > lob_len;
END LOOP;

DBMS_LOB.close(res);

END c2b;    
    begin
       for c_cur in (select "'||v_col||'" mycol, rowid rwid from "'||v_schema||'"."'||v_tab||'") loop
         if dbms_lob.getlength(c_cur.mycol) > 4000 then
          "'||v_schema||'".identifier.write_blob(null,v_blob_handle,v_blob);
          c2b(c_cur.mycol,v_blob);
           update "'||v_schema||'"."'||v_tab||'" 
              set newblobcol= '''||p_blob_prefix||'''||v_blob_handle
            where rowid= c_cur.rwid;
         else
           update "'||v_schema||'"."'||v_tab||'" 
              set newblobcol= c_cur.mycol
            where rowid= c_cur.rwid;
         end if;
       end loop;
    end;';
    
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" drop column "'||v_col||'"';
    execute immediate 'alter table "'||v_schema||'"."'||v_tab||'" rename column newblobcol to "'||v_col||'"';
  
  end loop;
  
  close c_cur;
  
end;
/

exit;

